local PortalMage = LibStub("AceAddon-3.0"):NewAddon("PortalMage")
local group = {}
local Masque

portalMageSpells = {["stormwind"] = true,
					["orgrimmar"] = true,
					["ironforge"] = true,
					["undercity"] = true,
					["darnassus"] = true,
					["thunderbluff"] = true,
					["exodar"] = true,
					["silvermoon"] = true,
					["theramore"] = true,
					["stonard"] = true,
					["dalaran"] = true,
					["shattrath"] = false,
					["northrend"] = false,
					["tolbarad"] = false,
					["pandaria"] = false,
					["stormshield"] = false,
					["warspear"] = false,
					["brokenisles"] = false,
					["orderhall"] = false,
					["boralus"] = false,
					["dazaralor"] = false,
					["oribos"] = false}

PortalMage.portals = {["stormwind"] = 10059,
					  ["orgrimmar"] = 11417,
					  ["ironforge"] = 11416,
					  ["undercity"] = 11418,
					  ["darnassus"] = 11419,
					  ["thunderbluff"] = 11420,
					  ["exodar"] = 32266,
					  ["silvermoon"] = 32267,
					  ["theramore"] = 49360,
					  ["stonard"] = 49361,
					  ["dalaran"] = 120146,
					  ["shattrathA"] = 33691,
					  ["shattrathH"] = 35717,
					  ["northrend"] = 53142,
					  ["tolbaradA"] = 88345,
					  ["tolbaradH"] = 88346,
					  ["pandariaA"] = 132620,
					  ["pandariaH"] = 132626,
					  ["stormshield"] = 176246,
					  ["warspear"] = 176244,
					  ["brokenisles"] = 224871,
					  ["orderhall"] = 193759,
					  ["boralus"] = 281400,
					  ["dazaralor"] = 281402,
					  ["oribos"] = 344597}

PortalMage.teleports = {["stormwind"] = 3561,
						["orgrimmar"] = 3567,
						["ironforge"] = 3562,
						["undercity"] = 3563,
						["darnassus"] = 3565,
						["thunderbluff"] = 3566,
						["exodar"] = 32271,
						["silvermoon"] = 32272,
						["theramore"] = 49359,
						["stonard"] = 49358,
						["dalaran"] = 120145,
						["shattrathA"] = 33690,
						["shattrathH"] = 35715,
						["northrend"] = 53140,
						["tolbaradA"] = 88342,
						["tolbaradH"] = 88344,
						["pandariaA"] = 132621,
						["pandariaH"] = 132627,
						["stormshield"] = 176248,
						["warspear"] = 176242,
						["brokenisles"] = 224869,
						["orderhall"] = 193759,
					    ["boralus"] = 281403,
					    ["dazaralor"] = 281404,
						["oribos"] = 344587}

PortalMage.icons = {["stormwind"] = "Interface/ICONS/Spell_Arcane_TeleportStormwind",
					["orgrimmar"] = "Interface/ICONS/Spell_Arcane_TeleportOrgrimmar",
					["ironforge"] = "Interface/ICONS/Spell_Arcane_TeleportIronforge",
					["undercity"] = "Interface/ICONS/Spell_Arcane_TeleportUndercity",
					["darnassus"] = "Interface/ICONS/Spell_Arcane_TeleportDarnassus",
					["thunderbluff"] = "Interface/ICONS/Spell_Arcane_TeleportThunderBluff",
					["exodar"] = "Interface/ICONS/Spell_Arcane_TeleportExodar",
					["silvermoon"] = "Interface/ICONS/Spell_Arcane_TeleportSilvermoon",
					["theramore"] = "Interface/ICONS/Spell_Arcane_TeleportTheramore",
					["stonard"] = "Interface/ICONS/Spell_Arcane_TeleportStonard",
					["dalaran"] = "Interface/ICONS/Spell_Arcane_TeleportDalaranCrater",
					["shattrath"] = "Interface/ICONS/Spell_Arcane_TeleportShattrath",
					["northrend"] = "Interface/ICONS/Spell_Arcane_TeleportDalaran",
					["tolbarad"] = "Interface/ICONS/Spell_Arcane_TeleportTolBarad",
					["pandaria"] = "Interface/ICONS/Spell_Arcane_ValeOfBlossoms",
					["stormshield"] = "Interface/ICONS/Spell_Arcane_TeleportStormshield",
					["warspear"] = "Interface/ICONS/Spell_Arcane_TeleportWarspear",
					["brokenisles"] = "Interface/ICONS/Spell_Arcane_TeleportDalaranBrokenIsles",
					["orderhall"] = "Interface/ICONS/Spell_Arcane_TeleportHallOfTheGuardian",
					["boralus"] = "Interface/ICONS/Spell_Arcane_PortalKulTiras",
					["dazaralor"] = "Interface/ICONS/Spell_Arcane_PortalZandalar",
					["oribos"] = "Interface/ICONS/Spell_Arcane_TeleportOribos"}

function PortalMage:OnInitialize()
	_, self.class = UnitClass("player")
	self.faction = UnitFactionGroup("player")
	if self.class == "MAGE" then
		self.frame = CreateFrame("FRAME", nil, UIParent)
		self.move = CreateFrame("FRAME", nil, self.frame, BackdropTemplateMixin and "BackdropTemplate")
		Masque = LibStub("Masque", true)
		if Masque ~= nil then
			group = Masque:Group("Portal Mage", "Buttons")
		end
		if not portalMageFrameX then
			portalMageFrameX = 300
		end
		if not portalMageFrameY then
			portalMageFrameY = 300
		end
		if portalMageVertical == nil then
			portalMageVertical = false
		end
		self:SetupFrame(self.frame)
		self:SetupMoveFrame(self.move)
		if self.faction == "Alliance" then
			local options = {
				name = "Portal Mage",
				handler = PortalMage,
				type = "group",
				args = {
					movable = {
						name = "Set Movable",
						type = "toggle",
						desc = "makes bar movable",
						set = "SetMove",
						get = "GetMove"
					},
					layout = {
						name = "Layout",
						type = "group",
						args = {
							vertical = {
								name = "Layout",
								type = "select",
								desc = "select layout type",
								values = {[true] = "Vertical", [false] = "Horizontal"},
								set = "SetLayout",
								get = "GetLayout",
								style = "radio"
							}
						}
					},
					portals = {
						name = "Portals",
						type = "group",
						args = {
							stormwind = {
								name = "Stormwind",
								type = "toggle",
								desc = "toggles portal and teleport to Stormwind",
								set = "Set",
								get = "Get"
							},
							ironforge = {
								name = "Ironforge",
								type = "toggle",
								desc = "toggles portal and teleport to Ironforge",
								set = "Set",
								get = "Get"
							},
							darnassus = {
								name = "Darnassus",
								type = "toggle",
								desc = "toggles portal and teleport to Darnassus",
								set = "Set",
								get = "Get"
							},
							exodar = {
								name = "Exodar",
								type = "toggle",
								desc = "toggles portal and teleport to Exodar",
								set = "Set",
								get = "Get"
							},
							theramore = {
								name = "Theramore",
								type = "toggle",
								desc = "toggles portal and teleport to Theramore",
								set = "Set",
								get = "Get"
							},
							dalaran = {
								name = "Dalaran Crater",
								type = "toggle",
								desc = "toggles portal and teleport to Dalaran Crater",
								set = "Set",
								get = "Get"
							},
							shattrath = {
								name = "Shattrath",
								type = "toggle",
								desc = "toggles portal and teleport to Shattrath",
								set = "Set",
								get = "Get"
							},
							northrend = {
								name = "Dalaran on Northrend",
								type = "toggle",
								desc = "toggles portal and teleport to Dalaran on Northrend",
								set = "Set",
								get = "Get"
							},
							tolbarad = {
								name = "Tol Barad",
								type = "toggle",
								desc = "toggles portal and teleport to Tol Barad",
								set = "Set",
								get = "Get"
							},
							pandaria = {
								name = "Vale of Eternal Blossoms",
								type = "toggle",
								desc = "toggles portal and teleport to Vale of Eternal Blossoms",
								set = "Set",
								get = "Get"
							},
							stormshield = {
								name = "Stormshield",
								type = "toggle",
								desc = "toggles portal and teleport to Stormshield",
								set = "Set",
								get = "Get"
							},
							brokenisles = {
								name = "Dalaran on Broken Isles",
								type = "toggle",
								desc = "toggles portal and teleport to Dalaran on Broken Isles",
								set = "Set",
								get = "Get"
							},
							orderhall = {
								name = "Hall of the Guardian",
								type = "toggle",
								desc = "toggles teleport to Hall of the Guardian(Mage Order Hall)",
								set = "Set",
								get = "Get"
							},
							boralus = {
								name = "Boralus",
								type = "toggle",
								desc = "toggles portal and teleport to Boralus",
								set = "Set",
								get = "Get"
							},
							oribos = {
								name = "Oribos",
								type = "toggle",
								desc = "toggles portal and teleport to Oribos",
								set = "Set",
								get = "Get"
							}
						}
					}
				}
			}
			LibStub("AceConfig-3.0"):RegisterOptionsTable("PortalMage", options, nil)
			LibStub("AceConfigDialog-3.0"):AddToBlizOptions("PortalMage", "Portal Mage")
		else
			local options = {
				name = "Portal Mage",
				handler = PortalMage,
				type = "group",
				args = {
					movable = {
						name = "Set Movable",
						type = "toggle",
						desc = "makes bar movable",
						set = "SetMove",
						get = "GetMove"
					},
					layout = {
						name = "Layout",
						type = "group",
						args = {
							vertical = {
								name = "Layout",
								type = "select",
								desc = "select layout type",
								values = {[true] = "Vertical", [false] = "Horizontal"},
								set = "SetLayout",
								get = "GetLayout",
								style = "radio"
							}
						}
					},
					portals = {
						name = "Portals",
						type = "group",
						args = {
							orgrimmar = {
								name = "Orgrimmar",
								type = "toggle",
								desc = "toggles portal and teleport to Orgrimmar",
								set = "Set",
								get = "Get"
							},
							undercity = {
								name = "Undercity",
								type = "toggle",
								desc = "toggles portal and teleport to Undercity",
								set = "Set",
								get = "Get"
							},
							thunderbluff = {
								name = "Thunder Bluff",
								type = "toggle",
								desc = "toggles portal and teleport to Thunder Bluff",
								set = "Set",
								get = "Get"
							},
							silvermoon = {
								name = "Silvermoon",
								type = "toggle",
								desc = "toggles portal and teleport to Silvermoon",
								set = "Set",
								get = "Get"
							},
							stonard = {
								name = "Stonard",
								type = "toggle",
								desc = "toggles portal and teleport to Stonard",
								set = "Set",
								get = "Get"
							},
							dalaran = {
								name = "Dalaran Crater",
								type = "toggle",
								desc = "toggles portal and teleport to Dalaran Crater",
								set = "Set",
								get = "Get"
							},
							shattrath = {
								name = "Shattrath",
								type = "toggle",
								desc = "toggles portal and teleport to Shattrath",
								set = "Set",
								get = "Get"
							},
							northrend = {
								name = "Dalaran on Northrend",
								type = "toggle",
								desc = "toggles portal and teleport to Dalaran on Northrend",
								set = "Set",
								get = "Get"
							},
							tolbarad = {
								name = "Tol Barad",
								type = "toggle",
								desc = "toggles portal and teleport to Tol Barad",
								set = "Set",
								get = "Get"
							},
							pandaria = {
								name = "Vale of Eternal Blossoms",
								type = "toggle",
								desc = "toggles portal and teleport to Vale of Eternal Blossoms",
								set = "Set",
								get = "Get"
							},
							warspear = {
								name = "Warspear",
								type = "toggle",
								desc = "toggles portal and teleport to Warspear",
								set = "Set",
								get = "Get"
							},
							brokenisles = {
								name = "Dalaran on Broken Isles",
								type = "toggle",
								desc = "toggles portal and teleport to Dalaran on Broken Isles",
								set = "Set",
								get = "Get"
							},
							orderhall = {
								name = "Hall of the Guardian",
								type = "toggle",
								desc = "toggles teleport to Hall of the Guardian(Mage Order Hall)",
								set = "Set",
								get = "Get"
							},
							dazaralor = {
								name = "Dazar'alor",
								type = "toggle",
								desc = "toggles portal and teleport to Dazar'alor",
								set = "Set",
								get = "Get"
							},
							oribos = {
								name = "Oribos",
								type = "toggle",
								desc = "toggles portal and teleport to Oribos",
								set = "Set",
								get = "Get"
							}
						}
					}
				}
			}
			LibStub("AceConfig-3.0"):RegisterOptionsTable("PortalMage", options, nil)
			LibStub("AceConfigDialog-3.0"):AddToBlizOptions("PortalMage", "Portal Mage")
		end
	end
end

function PortalMage:SetMove(info, val)
	if val then
		PortalMage.move:Show()
	else
		PortalMage.move:Hide()
	end
end

function PortalMage:GetMove(info)
	return PortalMage.move:IsShown()
end

function PortalMage:SetLayout(info, val)
	portalMageVertical = val
	if portalMageVertical then
		self:SetupButtonsVertical(self.frame, self.move)
	else
		self:SetupButtonsHorizontal(self.frame, self.move)
	end
end

function PortalMage:GetLayout(info)
	return portalMageVertical
end

function PortalMage:Set(info, val)
	portalMageSpells[info[#info]] = val
	if portalMageVertical then
		self:SetupButtonsVertical(self.frame, self.move)
	else
		self:SetupButtonsHorizontal(self.frame, self.move)
	end
	if Masque ~= nil then
		self:RemoveMasqueButtons()
		self:AddMasqueButtons()
		group:ReSkin()
	end
end

function PortalMage:Get(info)
	return portalMageSpells[info[#info]]
end

function PortalMage:AddMasqueButtons()
	if self.faction == "Alliance" then
		if portalMageSpells["stormwind"] then
			group:AddButton(self.button1)
		end
		if portalMageSpells["ironforge"] then
			group:AddButton(self.button2)
		end
		if portalMageSpells["darnassus"] then
			group:AddButton(self.button3)
		end
		if portalMageSpells["exodar"] then
			group:AddButton(self.button4)
		end
		if portalMageSpells["theramore"] then
			group:AddButton(self.button5)
		end
		if portalMageSpells["dalaran"] then
			group:AddButton(self.button6)
		end
		if portalMageSpells["shattrath"] then
			group:AddButton(self.button7)
		end
		if portalMageSpells["northrend"] then
			group:AddButton(self.button8)
		end
		if portalMageSpells["tolbarad"] then
			group:AddButton(self.button9)
		end
		if portalMageSpells["pandaria"] then
			group:AddButton(self.button10)
		end
		if portalMageSpells["stormshield"] then
			group:AddButton(self.button11)
		end
		if portalMageSpells["brokenisles"] then
			group:AddButton(self.button12)
		end
		if portalMageSpells["orderhall"] then
			group:AddButton(self.button13)
		end
		if portalMageSpells["boralus"] then
			group:AddButton(self.button14)
		end
		if portalMageSpells["oribos"] then
			group:AddButton(self.button15)
		end
	else
		if portalMageSpells["orgrimmar"] then
			group:AddButton(self.button1)
		end
		if portalMageSpells["undercity"] then
			group:AddButton(self.button2)
		end
		if portalMageSpells["thunderbluff"] then
			group:AddButton(self.button3)
		end
		if portalMageSpells["silvermoon"] then
			group:AddButton(self.button4)
		end
		if portalMageSpells["stonard"] then
			group:AddButton(self.button5)
		end
		if portalMageSpells["dalaran"] then
			group:AddButton(self.button6)
		end
		if portalMageSpells["shattrath"] then
			group:AddButton(self.button7)
		end
		if portalMageSpells["northrend"] then
			group:AddButton(self.button8)
		end
		if portalMageSpells["tolbarad"] then
			group:AddButton(self.button9)
		end
		if portalMageSpells["pandaria"] then
			group:AddButton(self.button10)
		end
		if portalMageSpells["warspear"] then
			group:AddButton(self.button11)
		end
		if portalMageSpells["brokenisles"] then
			group:AddButton(self.button12)
		end
		if portalMageSpells["orderhall"] then
			group:AddButton(self.button13)
		end
		if portalMageSpells["dazaralor"] then
			group:AddButton(self.button14)
		end
		if portalMageSpells["oribos"] then
			group:AddButton(self.button15)
		end
	end
end

function PortalMage:RemoveMasqueButtons()
	group:RemoveButton(self.button1)
	group:RemoveButton(self.button2)
	group:RemoveButton(self.button3)
	group:RemoveButton(self.button4)
	group:RemoveButton(self.button5)
	group:RemoveButton(self.button6)
	group:RemoveButton(self.button7)
	group:RemoveButton(self.button8)
	group:RemoveButton(self.button9)
	group:RemoveButton(self.button10)
	group:RemoveButton(self.button11)
	group:RemoveButton(self.button12)
	group:RemoveButton(self.button13)
	group:RemoveButton(self.button14)
	group:RemoveButton(self.button15)
end

function PortalMage.frameOnEvent(self, event, spell)
	if event == "PLAYER_LOGIN" then
		self:SetHeight(35)
		PortalMage.move:SetHeight(35);
		if portalMageVertical then
			PortalMage:SetupButtonsVertical(self, PortalMage.move)
		else
			PortalMage:SetupButtonsHorizontal(self, PortalMage.move)
		end
		if Masque ~= nil then
			PortalMage:AddMasqueButtons()
			group:ReSkin()
		end
		self:UnregisterEvent("PLAYER_LOGIN")
	elseif event == "LEARNED_SPELL_IN_TAB" and PortalMage:NewSpell(spell) then
		self:SetHeight(35)
		PortalMage.move:SetHeight(35);
		if portalMageVertical then
			PortalMage:SetupButtonsVertical(self, PortalMage.move)
		else
			PortalMage:SetupButtonsHorizontal(self, PortalMage.move)
		end
		if Masque ~= nil then
			PortalMage:RemoveMasqueButtons()
			PortalMage:AddMasqueButtons()
			group:ReSkin()
		end
	end
end

function PortalMage.frameOnDragStart(self)
	PortalMage.frame:StartMoving()
end

function PortalMage.frameOnDragStop(self)
	PortalMage.frame:StopMovingOrSizing()
	portalMageFrameX = PortalMage.frame:GetLeft()
	portalMageFrameY = PortalMage.frame:GetBottom()
end

function PortalMage:NewSpell(id)
	if self:SpellOnList(id) then
		for i = 121,135,1 do
			_, spell = GetActionInfo(i)
			if spell == id then
				return false
			end
		end
		return true
	end
	return false
end

function PortalMage:SpellOnList(id)
	local name = GetSpellInfo(id)
	for k, v in pairs(self.portals) do
		if name == v then 
			return true
		end
	end
	return false
end

function PortalMage:SetupFrame(frame)
	frame:SetMovable(true)
	frame:SetPoint("BOTTOMLEFT", portalMageFrameX, portalMageFrameY)
	frame:SetScale(0.9)
	frame:SetFrameStrata("LOW")
	frame:RegisterEvent("PLAYER_LOGIN")
	frame:RegisterEvent("LEARNED_SPELL_IN_TAB")
	frame:SetScript("OnEvent", PortalMage.frameOnEvent)
end

function PortalMage:SetupMoveFrame(frame)
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:SetClampedToScreen(true)
	frame:SetPoint("BOTTOMLEFT", 0, 0)
	frame:SetFrameStrata("HIGH")
	local backdrop = {
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		tile = false,
		tileSize = 0,
	}
	frame:SetBackdrop(backdrop)
	frame:SetBackdropColor(0, 0.75, 0.25, 0.75)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", PortalMage.frameOnDragStart)
	frame:SetScript("OnDragStop", PortalMage.frameOnDragStop)
	frame:Hide()
end

function PortalMage:SetupButtonsVertical(frame, move)
	self:ClearButtons()
	local length = 0
	if self.faction == "Alliance" then
		if portalMageSpells["stormwind"] then
			self.button1, length = self:SetupButtonVertical("PortalMageButton1", self.button1, length, "stormwind", 121, frame, PortalMage.icons["stormwind"])
		end
		if portalMageSpells["ironforge"] then
			self.button2, length = self:SetupButtonVertical("PortalMageButton2", self.button2, length, "ironforge", 122, frame, PortalMage.icons["ironforge"])
		end
		if portalMageSpells["darnassus"] then
			self.button3, length = self:SetupButtonVertical("PortalMageButton3", self.button3, length, "darnassus", 123, frame, PortalMage.icons["darnassus"])
		end
		if portalMageSpells["exodar"] then
			self.button4, length = self:SetupButtonVertical("PortalMageButton4", self.button4, length, "exodar", 124, frame, PortalMage.icons["exodar"])
		end
		if portalMageSpells["theramore"] then
			self.button5, length = self:SetupButtonVertical("PortalMageButton5", self.button5, length, "theramore", 125, frame, PortalMage.icons["theramore"])
		end
		if portalMageSpells["dalaran"] then
			self.button6, length = self:SetupButtonVertical("PortalMageButton6", self.button6, length, "dalaran", 126, frame, PortalMage.icons["dalaran"])
		end
		if portalMageSpells["shattrath"] then
			self.button7, length = self:SetupButtonVertical("PortalMageButton7", self.button7, length, "shattrathA", 127, frame, PortalMage.icons["shattrath"])
		end
		if portalMageSpells["northrend"] then
			self.button8, length = self:SetupButtonVertical("PortalMageButton8", self.button8, length, "northrend", 128, frame, PortalMage.icons["northrend"])
		end
		if portalMageSpells["tolbarad"] then
			self.button9, length = self:SetupButtonVertical("PortalMageButton9", self.button9, length, "tolbaradA", 129, frame, PortalMage.icons["tolbarad"])
		end
		if portalMageSpells["pandaria"] then
			self.button10, length = self:SetupButtonVertical("PortalMageButton10", self.button10, length, "pandariaA", 130, frame, PortalMage.icons["pandaria"])
		end
		if portalMageSpells["stormshield"] then
			self.button11, length = self:SetupButtonVertical("PortalMageButton11", self.button11, length, "stormshield", 131, frame, PortalMage.icons["stormshield"])
		end
		if portalMageSpells["brokenisles"] then
			self.button12, length = self:SetupButtonVertical("PortalMageButton12", self.button12, length, "brokenisles", 132, frame, PortalMage.icons["brokenisles"])
		end
		if portalMageSpells["orderhall"] then
			self.button13, length = self:SetupButtonVertical("PortalMageButton13", self.button13, length, "orderhall", 133, frame, PortalMage.icons["orderhall"])
		end
		if portalMageSpells["boralus"] then
			self.button14, length = self:SetupButtonVertical("PortalMageButton14", self.button14, length, "boralus", 134, frame, PortalMage.icons["boralus"])
		end
		if portalMageSpells["oribos"] then
			self.button15, length = self:SetupButtonVertical("PortalMageButton15", self.button15, length, "oribos", 135, frame, PortalMage.icons["oribos"])
		end
	else
		if portalMageSpells["orgrimmar"] then
			self.button1, length = self:SetupButtonVertical("PortalMageButton1", self.button1, length, "orgrimmar", 121, frame, PortalMage.icons["orgrimmar"])
		end
		if portalMageSpells["undercity"] then
			self.button2, length = self:SetupButtonVertical("PortalMageButton2", self.button2, length, "undercity", 122, frame, PortalMage.icons["undercity"])
		end
		if portalMageSpells["thunderbluff"] then
			self.button3, length = self:SetupButtonVertical("PortalMageButton3", self.button3, length, "thunderbluff", 123, frame, PortalMage.icons["thunderbluff"])
		end
		if portalMageSpells["silvermoon"] then
			self.button4, length = self:SetupButtonVertical("PortalMageButton4", self.button4, length, "silvermoon", 124, frame, PortalMage.icons["silvermoon"])
		end
		if portalMageSpells["stonard"] then
			self.button5, length = self:SetupButtonVertical("PortalMageButton5", self.button5, length, "stonard", 125, frame, PortalMage.icons["stonard"])
		end
		if portalMageSpells["dalaran"] then
			self.button6, length = self:SetupButtonVertical("PortalMageButton6", self.button6, length, "dalaran", 126, frame, PortalMage.icons["dalaran"])
		end
		if portalMageSpells["shattrath"] then
			self.button7, length = self:SetupButtonVertical("PortalMageButton7", self.button7, length, "shattrathH", 127, frame, PortalMage.icons["shattrath"])
		end
		if portalMageSpells["northrend"] then
			self.button8, length = self:SetupButtonVertical("PortalMageButton8", self.button8, length, "northrend", 128, frame, PortalMage.icons["northrend"])
		end
		if portalMageSpells["tolbarad"] then
			self.button9, length = self:SetupButtonVertical("PortalMageButton9", self.button9, length, "tolbaradH", 129, frame, PortalMage.icons["tolbarad"])
		end
		if portalMageSpells["pandaria"] then
			self.button10, length = self:SetupButtonVertical("PortalMageButton10", self.button10, length, "pandariaH", 130, frame, PortalMage.icons["pandaria"])
		end
		if portalMageSpells["warspear"] then
			self.button11, length = self:SetupButtonVertical("PortalMageButton11", self.button11, length, "warspear", 131, frame, PortalMage.icons["warspear"])
		end
		if portalMageSpells["brokenisles"] then
			self.button12, length = self:SetupButtonVertical("PortalMageButton12", self.button12, length, "brokenisles", 132, frame, PortalMage.icons["brokenisles"])
		end
		if portalMageSpells["orderhall"] then
			self.button13, length = self:SetupButtonVertical("PortalMageButton13", self.button13, length, "orderhall", 133, frame, PortalMage.icons["orderhall"])
		end
		if portalMageSpells["dazaralor"] then
			self.button14, length = self:SetupButtonVertical("PortalMageButton13", self.button14, length, "dazaralor", 134, frame, PortalMage.icons["dazaralor"])
		end
		if portalMageSpells["oribos"] then
			self.button15, length = self:SetupButtonVertical("PortalMageButton14", self.button15, length, "oribos", 135, frame, PortalMage.icons["oribos"])
		end
	end
	frame:SetWidth(35)
	move:SetWidth(35)
	frame:SetHeight(-length)
	move:SetHeight(-length)
	collectgarbage("collect")
end

function PortalMage:SetupButtonsHorizontal(frame, move)
	self:ClearButtons()
	local length = 0
	if self.faction == "Alliance" then
		if portalMageSpells["stormwind"] then
			self.button1, length = self:SetupButtonHorizontal("PortalMageButton1", self.button1, length, "stormwind", 121, frame, PortalMage.icons["stormwind"])
		end
		if portalMageSpells["ironforge"] then
			self.button2, length = self:SetupButtonHorizontal("PortalMageButton2", self.button2, length, "ironforge", 122, frame, PortalMage.icons["ironforge"])
		end
		if portalMageSpells["darnassus"] then
			self.button3, length = self:SetupButtonHorizontal("PortalMageButton3", self.button3, length, "darnassus", 123, frame, PortalMage.icons["darnassus"])
		end
		if portalMageSpells["exodar"] then
			self.button4, length = self:SetupButtonHorizontal("PortalMageButton4", self.button4, length, "exodar", 124, frame, PortalMage.icons["exodar"])
		end
		if portalMageSpells["theramore"] then
			self.button5, length = self:SetupButtonHorizontal("PortalMageButton5", self.button5, length, "theramore", 125, frame, PortalMage.icons["theramore"])
		end
		if portalMageSpells["dalaran"] then
			self.button6, length = self:SetupButtonHorizontal("PortalMageButton6", self.button6, length, "dalaran", 126, frame, PortalMage.icons["dalaran"])
		end
		if portalMageSpells["shattrath"] then
			self.button7, length = self:SetupButtonHorizontal("PortalMageButton7", self.button7, length, "shattrathA", 127, frame, PortalMage.icons["shattrath"])
		end
		if portalMageSpells["northrend"] then
			self.button8, length = self:SetupButtonHorizontal("PortalMageButton8", self.button8, length, "northrend", 128, frame, PortalMage.icons["northrend"])
		end
		if portalMageSpells["tolbarad"] then
			self.button9, length = self:SetupButtonHorizontal("PortalMageButton9", self.button9, length, "tolbaradA", 129, frame, PortalMage.icons["tolbarad"])
		end
		if portalMageSpells["pandaria"] then
			self.button10, length = self:SetupButtonHorizontal("PortalMageButton10", self.button10, length, "pandariaA", 130, frame, PortalMage.icons["pandaria"])
		end
		if portalMageSpells["stormshield"] then
			self.button11, length = self:SetupButtonHorizontal("PortalMageButton11", self.button11, length, "stormshield", 131, frame, PortalMage.icons["stormshield"])
		end
		if portalMageSpells["brokenisles"] then
			self.button12, length = self:SetupButtonHorizontal("PortalMageButton12", self.button12, length, "brokenisles", 132, frame, PortalMage.icons["brokenisles"])
		end
		if portalMageSpells["orderhall"] then
			self.button13, length = self:SetupButtonHorizontal("PortalMageButton13", self.button13, length, "orderhall", 133, frame, PortalMage.icons["orderhall"])
		end
		if portalMageSpells["boralus"] then
			self.button14, length = self:SetupButtonHorizontal("PortalMageButton13", self.button14, length, "boralus", 134, frame, PortalMage.icons["boralus"])
		end
		if portalMageSpells["oribos"] then
			self.button15, length = self:SetupButtonHorizontal("PortalMageButton14", self.button15, length, "oribos", 135, frame, PortalMage.icons["oribos"])
		end
	else
		if portalMageSpells["orgrimmar"] then
			self.button1, length = self:SetupButtonHorizontal("PortalMageButton1", self.button1, length, "orgrimmar", 121, frame, PortalMage.icons["orgrimmar"])
		end
		if portalMageSpells["undercity"] then
			self.button2, length = self:SetupButtonHorizontal("PortalMageButton2", self.button2, length, "undercity", 122, frame, PortalMage.icons["undercity"])
		end
		if portalMageSpells["thunderbluff"] then
			self.button3, length = self:SetupButtonHorizontal("PortalMageButton3", self.button3, length, "thunderbluff", 123, frame, PortalMage.icons["thunderbluff"])
		end
		if portalMageSpells["silvermoon"] then
			self.button4, length = self:SetupButtonHorizontal("PortalMageButton4", self.button4, length, "silvermoon", 124, frame, PortalMage.icons["silvermoon"])
		end
		if portalMageSpells["stonard"] then
			self.button5, length = self:SetupButtonHorizontal("PortalMageButton5", self.button5, length, "stonard", 125, frame, PortalMage.icons["stonard"])
		end
		if portalMageSpells["dalaran"] then
			self.button6, length = self:SetupButtonHorizontal("PortalMageButton6", self.button6, length, "dalaran", 126, frame, PortalMage.icons["dalaran"])
		end
		if portalMageSpells["shattrath"] then
			self.button7, length = self:SetupButtonHorizontal("PortalMageButton7", self.button7, length, "shattrathH", 127, frame, PortalMage.icons["shattrath"])
		end
		if portalMageSpells["northrend"] then
			self.button8, length = self:SetupButtonHorizontal("PortalMageButton8", self.button8, length, "northrend", 128, frame, PortalMage.icons["northrend"])
		end
		if portalMageSpells["tolbarad"] then
			self.button9, length = self:SetupButtonHorizontal("PortalMageButton9", self.button9, length, "tolbaradH", 129, frame, PortalMage.icons["tolbarad"])
		end
		if portalMageSpells["pandaria"] then
			self.button10, length = self:SetupButtonHorizontal("PortalMageButton10", self.button10, length, "pandariaH", 130, frame, PortalMage.icons["pandaria"])
		end
		if portalMageSpells["warspear"] then
			self.button11, length = self:SetupButtonHorizontal("PortalMageButton11", self.button11, length, "warspear", 131, frame, PortalMage.icons["warspear"])
		end
		if portalMageSpells["brokenisles"] then
			self.button12, length = self:SetupButtonHorizontal("PortalMageButton12", self.button12, length, "brokenisles", 132, frame, PortalMage.icons["brokenisles"])
		end
		if portalMageSpells["orderhall"] then
			self.button13, length = self:SetupButtonHorizontal("PortalMageButton13", self.button13, length, "orderhall", 133, frame, PortalMage.icons["orderhall"])
		end
		if portalMageSpells["dazaralor"] then
			self.button14, length = self:SetupButtonHorizontal("PortalMageButton13", self.button14, length, "dazaralor", 134, frame, PortalMage.icons["dazaralor"])
		end
		if portalMageSpells["oribos"] then
			self.button15, length = self:SetupButtonHorizontal("PortalMageButton14", self.button15, length, "oribos", 135, frame, PortalMage.icons["oribos"])
		end
	end
	frame:SetWidth(length)
	move:SetWidth(length)
	frame:SetHeight(35)
	move:SetHeight(35)
	collectgarbage("collect")
end

function PortalMage.buttonOnUpdate(self)
	if Masque ~= nil then
		group:ReSkin()
	end
end

function PortalMage:SetupButtonVertical(name, button, y, index, id, frame, icon)
	if button == nil then
		button = CreateFrame("CHECKBUTTON", name, frame, BackdropTemplateMixin and "BackdropTemplate, SecureActionButtonTemplate, ActionBarButtonTemplate")
	end
	button:Show()
	button:SetWidth(34)
	button:SetHeight(34)
	button:SetPoint("TOPLEFT", 0, y)
	button:SetFrameStrata("MEDIUM")
	button:SetAttribute("showgrid", 1)
	button:SetAttribute("action", id)
	button:SetAttribute("type", "spell")
	local name = GetSpellInfo(self.portals[index])
	button:SetAttribute("spell1", self.portals[index])
	button:SetAttribute("spell2", self.teleports[index])
	button:SetScript("OnUpdate", self.buttonOnUpdate)
	button:SetScript("OnEnter", function(self) 
					 GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
					 GameTooltip:AddLine("Left Click:")
					 GameTooltip:AddSpellByID(self:GetAttribute("spell1"))
					 GameTooltip:AddLine("\n")
					 GameTooltip:AddLine("Right Click:")
					 GameTooltip:AddSpellByID(self:GetAttribute("spell2"))
					 GameTooltip:Show()
					end)
	button:SetScript("OnLeave", function(self) 
					 GameTooltip:Hide()
					end)
	button:SetBackdrop({bgFile = icon,
					   tile = false,
					   insets = {left = 0,
								 right = 0,
								 top = 0,
								 bottom = 0}})
	return button, y - 35
end

function PortalMage:SetupButtonHorizontal(name, button, x, index, id, frame, icon)
	if button == nil then
		button = CreateFrame("CHECKBUTTON", name, frame, BackdropTemplateMixin and "BackdropTemplate, SecureActionButtonTemplate, ActionBarButtonTemplate")
	end
	button:Show()
	button:SetWidth(34)
	button:SetHeight(34)
	button:SetPoint("TOPLEFT", x, 0)
	button:SetFrameStrata("MEDIUM")
	button:SetAttribute("showgrid", 1)
	button:SetAttribute("action", id)
	button:SetAttribute("type", "spell")
	local name = GetSpellInfo(self.portals[index])
	button:SetAttribute("spell1", self.portals[index])
	button:SetAttribute("spell2", self.teleports[index])
	button:SetScript("OnEnter", function(self) 
					 GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
					 GameTooltip:AddLine("Left Click:")
					 GameTooltip:AddSpellByID(self:GetAttribute("spell1"))
					 GameTooltip:AddLine("\n")
					 GameTooltip:AddLine("Right Click:")
					 GameTooltip:AddSpellByID(self:GetAttribute("spell2"))
					 GameTooltip:Show()
					end)
	button:SetScript("OnLeave", function(self) 
					 GameTooltip:Hide()
					end)
	button:SetBackdrop({bgFile = icon,
					   tile = false,
					   insets = {left = 0,
								 right = 0,
								 top = 0,
								 bottom = 0}})
	return button, x + 35
end

function PortalMage:ClearButtons()
	self:ClearButton(self.button1, 121)
	self:ClearButton(self.button2, 122)
	self:ClearButton(self.button3, 123)
	self:ClearButton(self.button4, 124)
	self:ClearButton(self.button5, 125)
	self:ClearButton(self.button6, 126)
	self:ClearButton(self.button7, 127)
	self:ClearButton(self.button8, 128)
	self:ClearButton(self.button9, 129)
	self:ClearButton(self.button10, 130)
	self:ClearButton(self.button11, 131)
	self:ClearButton(self.button12, 132)
	self:ClearButton(self.button13, 133)
	self:ClearButton(self.button14, 134)
	self:ClearButton(self.button15, 135)
end

function PortalMage:ClearButton(button, id)
	if button ~= nil then
		button:Hide()
		button:SetAttribute("showgrid", 0)
		button:SetAttribute("action", id)
		button:SetAttribute("type", "spell")
	end
end